#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <bios.h>

#define _TCK 0x80
#define _TMS 0x40
#define _TDO 0x01

unsigned int oport = 0x378;  /* 室 ॣ LPT  */
unsigned int iport = 0x379;  /*  ॣ */

static unsigned int state;
char *cellname[121] =
{
	"din0",  "dout0",  "din1",  "dout1",  "din2",  "dout2",  "din3",  "dout3",
	"din4",  "dout4",  "din5",  "dout5",  "din6",  "dout6",  "din7",  "dout7",
	"din8",  "dout8",  "din9",  "dout9",  "din10", "dout10", "din11", "dout11",
	"din12", "dout12", "din13", "dout13", "din14", "dout14", "din15", "dout15",
	"din16", "dout16", "din17", "dout17", "din18", "dout18", "din19", "dout19",
	"din20", "dout20", "din21", "dout21", "din22", "dout22", "din23", "dout23",
	"din24", "dout24", "din25", "dout25", "din26", "dout26", "din27", "dout27",
	"din28", "dout28", "din29", "dout29", "din30", "dout30", "din31", "dout31",
	"cpa",   "Nenout", "Nce",   "lock",   "bigend", "Ncpi",  "dbe",   "Nbw",
	"mclk",  "Nwait",  "lateabt", "prog32", "data32", "Nrw", "Nopc",  "Nmreq",
	"seq",   "abort",  "Nirq",  "Nfiq",   "Nreset", "ale",   "cpb",   "Ntrans",
	"a31",   "a30",    "a29",   "a28",    "a27",    "a26",   "a25",   "a24",
	"a23",   "a22",    "a21",   "a20",    "a19",    "a18",   "a17",   "a16",
	"a15",   "a14",    "a13",   "a12",    "a11",    "a10",   "a09",   "a08",
	"a07",   "a06",    "a05",   "a04",    "a03",    "a02",   "a01",   "a00",
	"abe"
};

inline int TDI(void) {
	return (inport(iport) & 0x80) != 0x80;
}


inline void TCK(int x) {
	if(x) state |= _TCK; else state &= ~_TCK;
   outport(oport, state);
}
inline void TCK_1_0(void) {
/*
	state |=  _TCK; outport(oport, state);
   state &= ~_TCK; outport(oport, state);
*/
	outport(oport, state | _TCK); /* ⠥,   室  ᥣ TCK=0*/
   outport(oport, state);
}


inline void TMS(int x) {
	if(x) state |= _TMS; else state &= ~_TMS;
   outport(oport, state);
}

inline void TDO(int x) {
	if(x) state |= _TDO; else state &= ~_TDO;
   outport(oport, state);
}

void ResetJTAG(void) {
   TMS(1); /*  ஫ JTAG 䥩 */
   TCK(0); for(int i=0; i<5; i++) { TCK_1_0(); }
   TMS(0); TCK_1_0(); /* -> Run-Test/Idle */
   TMS(1); TCK_1_0(); /* -> Select-DR-Scan */
}

void Command(int x) {

   TMS(1); TCK_1_0(); /* -> Select-IR-Scan */
   TMS(0); TCK_1_0(); /* -> Capture-IR */
   /*  0*/ TCK_1_0();

   TDO(x&1); TCK_1_0();
   TDO(x&2); TCK_1_0();
   TDO(x&4); TCK_1_0();
		TMS(1); /* ⮢   横 */
   TDO(x&8); TCK_1_0();
   /*  1*/ TCK_1_0(); /* -> Update-IR      */
   /*  1*/ TCK_1_0(); /* -> Select-DR-Scan */
}


void ExenData(unsigned char *p, int bits) {

   TMS(0); TCK_1_0(); /* -> Capture-DR     */
   /*  0*/ TCK_1_0(); /* -> Shift-DR       */

   for(int i=0; i<bits; i++) {
		TDO(*p); TCK(1); *p++ = TDI(); TCK(0);
   }
   TMS(1); /* ⮢   横 + ᫥  */
   TDO(*p); TCK(1); *p++ = TDI(); TCK(0); /* -> Exit1-DR  */

   /*  1*/ TCK_1_0(); /* -> Update-DR */
   /*  1*/ TCK_1_0(); /* -> Select-DR-Scan */
}


/**************************************************************************/
void main(void) {

  unsigned char buf[121];

   directvideo = 1; /* ⠥ ।⢥  VRAM */
   clrscr();
	gotoxy(1, 23);
	cprintf("Hello!");


   ResetJTAG();

	Command(0xE);  /* 㦠  IDCODE */
   ExenData(buf, 32);

   long ID=0;
   for(int i=0;i<32;i++) { ID+=buf[31-i] + ID; }
	gotoxy(1, 25);
   cprintf("JTAG ID code:%08lX", ID);


   for(int k=0; k<sizeof(cellname)/sizeof(char *); k++) {
		gotoxy(1 + (k/21)*13, 1 + (k % 21));
		cprintf("%8s->", cellname[k]);
   }

   FILE *adr_log;
   adr_log=fopen("adr.log","w");
	if(adr_log) do {
		Command(0x3);  /* 㦠  SAMPLE/PRELOAD */
	   ExenData(buf, 121);

	   for(int k=64; k<88; k++) {
			gotoxy(11 + (k/21)*13, 1 + (k % 21));
			cprintf("%d", buf[120-k]);
	   }
      int k=120;
		gotoxy(11 + (k/21)*13, 1 + (k % 21));
		cprintf("%d", buf[120-k]);

   gotoxy(30, 25);

   unsigned long adr;
   adr=0;
	for(int i=0;i<32;i++) { adr+=buf[32-i] + adr; }
	cprintf("A:%08lX", adr);

   gotoxy(45, 25);
   unsigned long dou;
   dou=0;
	for(int i=57;i<120;i+=2) { dou+=buf[i] + dou; }
	cprintf("DOUT:%08lX", dou);

   gotoxy(60, 25);
   unsigned long din;
   din=0;
	for(int i=56;i<121;i+=2) { din+=buf[i] + din; }
	cprintf("DIN:%08lX", din);

   	fprintf(adr_log,"%08lX", adr);
   	fprintf(adr_log,"%c", (adr&3)?'*':':');
   	fprintf(adr_log,"i %08lX", din);
   	if((buf[41]==0)&&(buf[43]==0))fprintf(adr_log,", o %08lX", dou);
   	fprintf(adr_log,"\n");

	} while(!bioskey(1));

}
